#ifndef CALCULATOR_H
#define CALCULATOR_H

#include <QWidget>
#include <QStack>
class QLCDNumber;
class QPushButton;
class QGridLayout;
class QRadioButton;
class QHBoxLayout;

class Calculator : public QWidget
{
    Q_OBJECT

public:
    Calculator(QWidget* parent = nullptr);
    ~Calculator();
    void calctr();

private:
    QLCDNumber* f_LcNum;
    QRadioButton* f_radioBtnStandard;
    QRadioButton* f_radioBtnScient;

    QStack<QString> f_operStack;
    QString f_currentNum;
    bool f_if_curChangable;

    QGridLayout* f_BtnLayoutStandard;
    QGridLayout* f_BtnLayoutScientExtra;
    QWidget* f_BtnLayoutScientExtraWidget;
    QWidget* f_BtnLayoutStandardExtraWidget;

    QHBoxLayout* f_HBoxBtnLayout;

    QGridLayout* MainLayout;


    const double PI = 3.141592654;
    const QVector<QString> NumND = { "e", "pi" };
    const QVector<QString> UnOp = { "rev", "sqr", "sqrt", "-x", "sin", "cos", "tan", "tanh", "sinh", "cosh", "ln", "exp", "n!", "cub root", "cub sqr" };
    const QVector<QString> OpToCountimmediately = { "log", "ysqr", "ysqrt" };
    const QVector<QString> SumOp = { "+", "-" };

    QPushButton* createButton(const QString& pStr, size_t pHoriz, size_t pVert);

public slots:
    void slotButtonClicked();
    void slotHideScient(bool);
    void slotShowScient(bool);

};
#endif // CALCULATOR_H
